////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT REDISTRIBUTABLE OR APPROVED FOR USE IN/ON ANY OTHER UI 
//  ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) David M. Bandler/DMB Software Technologies.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var settings12HourClock = true;
var settingsShowAMPM = true;
var settingsShowAMPMLED = true;

var settingShowSeconds = true;
var settingShowDate = true;
var settingsShowDateLong = true;

var settingsClockFaceDisplayColor = "#F20000";

var settingsAlarmEnabled = false;


var clockIntervalID = 0;

var firstBoot = true;

var backgroundsMaximum = 10;

var originalColor = "#F20000";
var blinkColor = "#F2F200";

////////////////////////////////////////////////////////////////////////////////
//
// Debug: Write error messages to debug logging
//
////////////////////////////////////////////////////////////////////////////////
function handleErr(msg, url, l) {
    dbgOut("Problem: " + msg + "\nLine: " + l);
    return true;
}

////////////////////////////////////////////////////////////////////////////////
//
// Initialize
//
////////////////////////////////////////////////////////////////////////////////
window.onerror = handleErr;
System.Gadget.settingsUI = "Settings.htm";
System.Gadget.onSettingsClosed = settingsClosed;
System.Gadget.onShowSettings = settingsOpen;
System.Gadget.onDock = resizeGadget;
System.Gadget.onUndock = resizeGadget;
System.Gadget.visibilityChanged = gadgetVisibilityChange;

// Specify the Flyout root.
System.Gadget.Flyout.file = "FlyoutAlarmSettings.htm";
var oGadgetDocument = System.Gadget.document.parentWindow;
var oGadgetFlyoutDocument = System.Gadget.Flyout.document.parentWindow;
System.Gadget.Flyout.onShow = showFlyout;
System.Gadget.Flyout.onHide = hideFlyout;


// Initialize the gadget.
function init() {

    loadSettings();

    if (settingsAlarmEnabled) {
        //alarmSnooze.value = "Off";
        document.getElementById("Alarm").style.visibility = "visible";
        alarmSnooze.disabled = false;
    }
    else {
       // alarmSnooze.value = "On";
        document.getElementById("Alarm").style.visibility = "hidden";
        alarmSnooze.disabled = true;
    }
    
    updateClock();
    clockIntervalID = setInterval("updateClock()", 1000);
    
    if (firstBoot == true)	
    {
        dbgOut("First boot");
        firstBoot = false;
        
    } 
    else 
    {

    }
}

function closeit() {
    clearInterval(clockIntervalID);
    clearInterval(snoozeAlarmID);
    clearInterval(soundAlarmID);
    clearInterval(blinkClockID);
}

document.onreadystatechange = function() {
    if (document.readyState == "complete") {
        //init();
    }
}

function resizeGadget() {
    /* if (System.Gadget.docked) {
        clockGadget.style.height = "75px";
        clockGadget.style.width = "130px"; //Don't Change
        
        var oBackground = document.getElementById("imgBackground");
        //oBackground.src = "url(" + settingsCurrentBackground + ")";
    }
    else {
        clockGadget.style.height = "231px"; //231px
        clockGadget.style.width = "400px"; //Don't Change - 400px
        
        var oBackground = document.getElementById("imgBackground");
        //oBackground.src = "url(" + settingsCurrentBackgroundUndock + ")";
    } */
}

////////////////////////////////////////////////////////////////////////////////
//
// Force an update to occur when the gadget becomes visible again
//
////////////////////////////////////////////////////////////////////////////////
function gadgetVisibilityChange() {
    if (firstBoot == true) { return; }

    if (System.Gadget.visible) { dbgOut("Gadget is now visible..."); }
    else { dbgOut("Gadget is no longer visible"); }

}

////////////////////////////////////////////////////////////////////////////////
//
// Set state for the opening the settings window
//
////////////////////////////////////////////////////////////////////////////////
function settingsOpen(evt) {
    
}

////////////////////////////////////////////////////////////////////////////////
//
// Set state after the settings window is closed
//
////////////////////////////////////////////////////////////////////////////////
function settingsClosed(event)
{
    if(event.closeAction == event.Action.commit)
    {
        init();        
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// Load persisted settings for the gadget
//
////////////////////////////////////////////////////////////////////////////////
function loadSettings() {

    var alarmOn = System.Gadget.Settings.read("alarmEnabled");
    if (alarmOn == "") { settingsAlarmEnabled = false; }
    else {
        if (alarmOn == true) { settingsAlarmEnabled = true; } else { settingsAlarmEnabled = false; }
    }

    // Load the default background image
    if (System.Gadget.Settings.read("settingsBackgroundCurrent") == "") {
        currentBackground = 1;
    }
    else {
        var currentBackground = System.Gadget.Settings.read("settingsBackgroundCurrent");
        if (currentBackground == "") { currentBackground = 1; }
        if (isNaN(currentBackground)) { currentBackground = 1; }
        if (backgroundsMaximum < currentBackground) { currentBackground = backgroundsMaximum; }
        if (currentBackground < 0) { currentBackground = 1; }
    }

    var oBackground = document.getElementById("imgBackground");
    oBackground.src = "images/Default Background " + currentBackground + ".png";

    var snoozeButtonColors = new Array("3333cc", "cc3333", "cacc33", "cc9433", "50cc33", "33cc82", "33ccbf", "337fcc", "7733cc", "ca33cc");
    alarmSnooze.style.backgroundColor = "#" + snoozeButtonColors[currentBackground - 1];
    

    var setShowSec = System.Gadget.Settings.read("settingsShowSeconds");
    if (setShowSec == "") { settingShowSeconds = true; }
    else {
        if (setShowSec == "true") { settingShowSeconds = true; }
        else { settingShowSeconds = false; }
    }

    var setShowDate = System.Gadget.Settings.read("settingsShowDate");
    if (setShowDate == "") { settingShowDate = true; }
    else {
        if (setShowDate == "true") { settingShowDate = true; }
        else { settingShowDate = false; }
    }

    var setShowdateFormat = System.Gadget.Settings.read("settingsShowDateFormat");
    if (setShowdateFormat == "") { settingsShowDateLong = true; }
    else {
        if (setShowdateFormat == "true") { settingsShowDateLong = false; }
        else { settingsShowDateLong = true; }
    }

    var setTimeFormat = System.Gadget.Settings.read("settingsTimeFormat");
    if (setTimeFormat == "") {
        settings12HourClock = true;
        settingsShowAMPM = true;
    }
    else {
        if (setTimeFormat == "true") {
            settings12HourClock = true;
            settingsShowAMPM = true;
        }
        else {
            settings12HourClock = false;
            settingsShowAMPM = false;
        }
    }

    var setTimeFormatAMPM = System.Gadget.Settings.read("settingsTimeFormat12HourShowAMPM");
    if (setTimeFormatAMPM == "") { settingsShowAMPMLED = false; }
    else {
        if (setTimeFormatAMPM == "true") { settingsShowAMPMLED = false; }
        else { settingsShowAMPMLED = true; }
    }


    var oClockFace = document.getElementById("clockFace");
    clockFace.color = settingsClockFaceDisplayColor;
    
    /*propShowOrganizer = System.Gadget.Settings.read("showOrganizer");
    propShowPrivateAppts = System.Gadget.Settings.read("showPrivateAppts");
    if (propShowPrivateAppts != "true") {
        propShowPrivateAppts = "false";
    }
    propGadgetSize = System.Gadget.Settings.read("gadgetSize");
    if ("large" != propGadgetSize) {
        propGadgetSize = "normal";
    }*/

}

// --------------------------------------------------------------------
// Display the Flyout state in the gadget.
// --------------------------------------------------------------------
function showFlyout() {
    //System.Gadget.Flyout.show = true;
    // bshow = System.Gadget.Flyout.show

}

// --------------------------------------------------------------------
// Hide the flyout and display the Flyout state in the gadget.
// --------------------------------------------------------------------
function hideFlyout() {
    System.Gadget.Flyout.show = false;
    init();

}


function updateClock() {
    var currentTime = new Date();

    var currentHours = currentTime.getHours();
    var currentMinutes = currentTime.getMinutes();

    // Pad the minutes and seconds with leading zeros, if required
    currentMinutes = (currentMinutes < 10 ? "0" : "") + currentMinutes;

    // Choose either "AM" or "PM" as appropriate
    var timeOfDay = (currentHours < 12) ? "AM" : "PM";

    if (settings12HourClock == true) {
        // Convert the hours component to 12-hour format if needed
        currentHours = (currentHours > 12) ? currentHours - 12 : currentHours;

        // Convert an hours component of "0" to "12"
        currentHours = (currentHours == 0) ? 12 : currentHours;
    }

    // Compose the string for display
    var currentTimeString = currentHours + ":" + currentMinutes;

    // Check to see if we should show the seconds and if so, show them
    if (settingShowSeconds == true) {
        var currentSeconds = currentTime.getSeconds();
        currentSeconds = (currentSeconds < 10 ? "0" : "") + currentSeconds;
        currentTimeString = currentTimeString + ":" + currentSeconds; 
    }

    // Check to see if we should show the AM/PM/LED and if so, show it
    if (settingsShowAMPM == true) {
        // Choose either "AM" or "PM" as appropriate
        // var timeOfDay = (currentHours < 12) ? "AM" : "PM";

        if (settingsShowAMPMLED == true) {
            clockFace.style.textAlign = "center";
            // Show LED PM Indicator
            if (timeOfDay == "PM") {
                document.getElementById("LED").style.visibility = "visible"; 
            }
            else {
               document.getElementById("LED").style.visibility = "hidden"; 
            }
        }
        else {
            // Show AM/PM Text
            currentTimeString = currentTimeString + " " + timeOfDay;
            clockFace.style.textAlign = "right";
            document.getElementById("LED").style.visibility = "hidden"; 
        }
    }
    
    // Check to see if we should show the date and if so, show it
    if (settingShowDate == true) {
        document.getElementById("clockFaceDate").style.visibility = "visible"; 
        var month = currentTime.getMonth() + 1;
        var day = currentTime.getDate();
        var year = currentTime.getFullYear();

        if (settingsShowDateLong == true) {
            // Show the long date
            var Months = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
            document.getElementById("clockFaceDate").firstChild.nodeValue = Months[month - 1] + " " + day + ", " + year;
        }
        else {
            // Show the short date
            document.getElementById("clockFaceDate").firstChild.nodeValue = month + "/" + day + "/" + year;
        }
    }
    else {
         document.getElementById("clockFaceDate").style.visibility = "hidden";  
    }
    

    // Update the time display
    document.getElementById("clockFace").firstChild.nodeValue = currentTimeString;

    if (settingsAlarmEnabled == true) {
        // If the alarm is on, then let's check to see if we need to sound the alarm
        var aAMPM = System.Gadget.Settings.read("alarmAMPM");
        
        var aHour = System.Gadget.Settings.read("alarmHours");
        if (settings12HourClock == true) {
            //12-Hour Clock - Make sure alarm is set for 12-hour time
            if (aHour > 11) { aHour = (aHour - 12); aAMPM = 1; }
            if (aHour == 0) { aHour = 12; }
        }
        else {
            //24-Hour Clock - Make sure alarm is set for 24-hour time
            if (aHour < 11 && aAMPM > 0) {
                aHour = (aHour + 12);
            }
        }

        if (aAMPM == 1) { aAMPM = "PM"; } else { aAMPM = "AM"; }
        
        var aMin = System.Gadget.Settings.read("alarmMinutes");



        if (snoozing == true) {
            // If we're snoozing, then we won't need to sound the alarm

        }
        else {
            // We're not snoozing, so let's check to make sure the alarm is not already going off
            if (alarmSounding != true) {

                if (aHour == currentHours && aMin == currentMinutes) {

                    if (settings12HourClock == true) {
                        //12-Hour Clock - Check to make sure it's the correct AM/PM
                        if (aAMPM == timeOfDay) {
                            soundAlarm();
                        }
                        
                    }
                    else {
                        //24-Hour clock, We have the right time
                        soundAlarm();
                    }
                    
                 }
                
                
            }
            else {
                //The alarm is already sounding, so we don't need to touch anything
                
            }

        }


    }


}

var songVal = 0;
var songNull = null;

var soundAlarmID = 0;

var blinked = false;

var blinkClockID = 0;

function blinkClock() {

    if (blinked != true) {
        blinked = true;
        clockFace.style.color = blinkColor;
        clockFaceDate.style.color = blinkColor;
    }
    else {
        blinked = false;
        clockFace.style.color = originalColor;
        clockFaceDate.style.color = originalColor;
    }

}

function soundAlarmPlay() {
    //System.Sound.playSound("\\windows\\media\\chord.wav");
    songVal = System.Sound.playSound("sounds/alarm 1.wav");
}

function soundAlarm() {
    alarmSounding = true;
    alarmSnooze.disabled = false;
    snoozing = false;
    soundAlarmPlay();
    soundAlarmID = setInterval("soundAlarmPlay()", 30000); // Sound alarm every 3 seconds until turned off
    blinkClockID = setInterval("blinkClock()", 500);
}

function disableAlarm() {
    clearInterval(snoozeAlarmID);
    clearInterval(soundAlarmID);
    clearInterval(blinkClockID);
    clockFace.style.color = originalColor;
    clockFaceDate.style.color = originalColor;
    blinked = false;
    songVal = System.Sound.playSound(songNull);
    alarmSounding = false;
    snoozing = false;
    settingsAlarmEnabled = false;
    alarmSnooze.disabled = true;    
}

var snoozeAlarmID = 0;

function snoozeAlarm() {
    clearInterval(soundAlarmID);
    clearInterval(blinkClockID);
    clockFace.style.color = originalColor;
    clockFaceDate.style.color = originalColor;
    blinked = false;
    songVal = System.Sound.playSound(songNull);
    alarmSnooze.disabled = true;
    snoozing = true;
    snoozeAlarmID = setInterval("soundAlarm()", 300000); // Snooze for 5 minutes (300,000 milliseconds)

}


var snoozing = false;
var alarmSounding = false;

function snoozeButtonClick() {



    if (alarmSounding == true) {
        // Alarm is sounding, we are going to snooze
        if (snoozing != true) {
            // Alarm is going off, we're not snoozing, so let's snooze
            snoozeAlarm();
        }
        else {
            // We are snoozing, so let's turn the alarm off

        }
    }
    else {
        // Alarm is not sounding
        //
        
    }

}


function alarmButtonClick() {
    System.Gadget.Flyout.show = true;
}

function alarmButtonMouseOver() {
    alarmButton.style.color = "#F2F200";
}

function alarmButtonMouseOut() {
    alarmButton.style.color = "#FFFFFF";
}








function pageLoad() { window.detachEvent("onload", pageLoad); window.attachEvent("onunload", pageUnload); init(); }
function pageUnload() { window.detachEvent("onunload", pageUnload); closeit(); }
window.attachEvent("onload", pageLoad);









