////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT REDISTRIBUTABLE OR APPROVED FOR USE IN/ON ANY OTHER UI 
//  ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) David M. Bandler/DMB Software Technologies.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
window.onerror = handleErr;



////////////////////////////////////////////////////////////////////////////////
//
//  
//
////////////////////////////////////////////////////////////////////////////////
function init() {
    var oGadgetDocument = System.Gadget.document.parentWindow;


    lstHours.options.length = 0;
    
    if (oGadgetDocument.settings12HourClock != true) 
    {
        lstAMPM.style.visibility = "hidden";
        for (var index = 0; index < 24; index++) {
            lstHours.options[lstHours.options.length] = new Option(index, index);
        }
    }
    else 
    {
        lstAMPM.style.visibility = "visible";
        for (var index = 0; index < 12; index++) {
            var Hour = index;
            if (index == 0) { Hour = 12; }
            lstHours.options[lstHours.options.length] = new Option(Hour, Hour);
        }
    }



    lstMinutes.options.length = 0;

    for (var index = 0; index < 60; index++) {
        if (index < 10) { index = "0" + index; }
        lstMinutes.options[lstMinutes.options.length] = new Option(index, index);
    }


    var AMPM = System.Gadget.Settings.read("alarmAMPM");
    if (AMPM == "" || AMPM > 2) { lstAMPM.selectedIndex = 0; }
    else {
        lstAMPM.selectedIndex = AMPM;
    }
    

    var Hours = System.Gadget.Settings.read("alarmHours");

    if (Hours == "" || Hours > 23) { lstHours.selectedIndex = 0; }
    else {
        if (oGadgetDocument.settings12HourClock != true) {
            //24-Hour Clock
            if (Hours > 11) {
                lstHours.selectedIndex = Hours;
            }
            else {
                if (AMPM > 0) {
                    lstHours.selectedIndex = (Hours + 12);
                }
                else {
                    lstHours.selectedIndex = Hours;
                }
            }
            
            

        }
        else {
            //12-Hour Clock
            if (Hours > 11) {
                lstHours.selectedIndex = (Hours - 12);
                lstAMPM.selectedIndex = 1;
            }
            else {
                lstHours.selectedIndex = Hours;
            }



        }
        
        
        
    }
    
    
    


    var Minutes = System.Gadget.Settings.read("alarmMinutes");
    if (Minutes == "" || Minutes > 59) { lstMinutes.selectedIndex = 0; }
    else {
        lstMinutes.selectedIndex = Minutes;
    }


    if (oGadgetDocument.settingsAlarmEnabled == true) {
        rdoAlarmToggleOn.checked = true;
        rdoAlarmToggleOff.checked = false;
        alarmTimeOptions.disabled = false;
    }
    else {
        rdoAlarmToggleOn.checked = false;
        rdoAlarmToggleOff.checked = true;
        alarmTimeOptions.disabled = true;
    }
    
    
 
    
    
    
}

////////////////////////////////////////////////////////////////////////////////
//
//  
//
////////////////////////////////////////////////////////////////////////////////
function alarmToggleOnclick() {
    var oGadgetDocument = System.Gadget.document.parentWindow;

    

    if (rdoAlarmToggleOn.checked) {
        oGadgetDocument.Alarm.style.visibility = "visible";
        oGadgetDocument.settingsAlarmEnabled = true;
        oGadgetDocument.snoozing = false;
        oGadgetDocument.alarmSounding = false;

        System.Gadget.Settings.write("alarmHours", lstHours.selectedIndex);
        System.Gadget.Settings.write("alarmMinutes", lstMinutes.selectedIndex);
        System.Gadget.Settings.write("alarmAMPM", lstAMPM.selectedIndex);
        System.Gadget.Settings.write("alarmEnabled", true);
        alarmTimeOptions.disabled = false;
        
        
        //oGadgetDocument.alarmSnooze.disabled = false;
    }
    else {
        oGadgetDocument.Alarm.style.visibility = "hidden";
        oGadgetDocument.settingsAlarmEnabled = false;
        oGadgetDocument.disableAlarm();
        oGadgetDocument.snoozing = false;
        oGadgetDocument.alarmSounding = false;
        //oGadgetDocument.alarmSnooze.disabled = false;
        System.Gadget.Settings.write("alarmEnabled", false);
        alarmTimeOptions.disabled = true;
    }


}


function alarmTimeChange() {
    System.Gadget.Settings.write("alarmHours", lstHours.selectedIndex);
    System.Gadget.Settings.write("alarmMinutes", lstMinutes.selectedIndex);
    System.Gadget.Settings.write("alarmAMPM", lstAMPM.selectedIndex);
    if (rdoAlarmToggleOn.checked == true) { System.Gadget.Settings.write("alarmEnabled", true); } else { System.Gadget.Settings.write("alarmEnabled", false); }
}



////////////////////////////////////////////////////////////////////////////////
//
// Debug: Write error messages to debug logging
//
////////////////////////////////////////////////////////////////////////////////
function handleErr(msg, url, l) {
    System.Debug.outputString("Problem: " + msg + "\nLine: " + l);
    return true;
}