////////////////////////////////////////////////////////////////////////////////
//
//  THIS CODE IS NOT REDISTRIBUTABLE OR APPROVED FOR USE IN/ON ANY OTHER UI 
//  ELEMENT OR PRODUCT COMPONENT.
//  Copyright (c) David M. Bandler/DMB Software Technologies.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
window.onerror = handleErr;
System.Gadget.onSettingsClosing = SettingsClosing;

var backgroundsMaximum = 10;
var backgroundsCurrent = 1;

////////////////////////////////////////////////////////////////////////////////
//
// Setup the gadget
//
////////////////////////////////////////////////////////////////////////////////
function init() {

    document.getElementById("backgroundPickerTotal").firstChild.nodeValue = backgroundsMaximum;

    if (System.Gadget.Settings.read("settingsBackgroundCurrent") == "") { backgroundsCurrent = 1; }
    else {
        backgroundsCurrent = System.Gadget.Settings.read("settingsBackgroundCurrent");
        if (backgroundsCurrent == "") { backgroundsCurrent = 1; }
        if (isNaN(backgroundsCurrent)) { backgroundsCurrent = 1; }
        if (backgroundsMaximum < backgroundsCurrent) { backgroundsCurrent = backgroundsMaximum; }
        if (backgroundsCurrent < 0) { backgroundsCurrent = 1; }
    }

    document.getElementById("backgroundPickerCurrent").firstChild.nodeValue = backgroundsCurrent;
    document.getElementById("backgroundBackgroundChoiceDisplay").src = "images/Default Background " + backgroundsCurrent + ".png";



    var setShowSec = System.Gadget.Settings.read("settingsShowSeconds");
    // If var is empty, then set to default, otherwise let's get the value
    if (setShowSec == "") { chkShowSeconds.checked = true; }
    else {
        if (setShowSec == "true") {
            chkShowSeconds.checked = true;
        }
        else {
            chkShowSeconds.checked = false;
        }
    }

    var setShowDate = System.Gadget.Settings.read("settingsShowDate");
    // If var is empty, then set to default, otherwise let's get the value
    if (setShowDate == "") { chkShowDate.checked = true; }
    else {
        if (setShowDate == "true") {
            chkShowDate.checked = true;
        }
        else {
            chkShowDate.checked = false;
        }
    }

    var setShowdateFormat = System.Gadget.Settings.read("settingsShowDateFormat");
    // If var is empty, then set to default value
    if (setShowdateFormat == "") {
        rdoShowLongDate.checked = true;
        rdoShowShortDate.checked = false;
    }
    else {
        // Otherwise, let's determine what the value holds and assign appropriately
        if (setShowdateFormat == "true") {
            rdoShowShortDate.checked = true;
            rdoShowLongDate.checked = false;
        }
        else {
            rdoShowLongDate.checked = true;
            rdoShowShortDate.checked = false;
        }
    }

    var setTimeFormat = System.Gadget.Settings.read("settingsTimeFormat");
    // If var is empty, then set to default value
    if (setTimeFormat == "") {
        rdoShow12Hours.checked = true;
        rdoShow24Hours.checked = false;
    }
    else {
        // Otherwise determine value and assign appropriately
        if (setTimeFormat == "true") {
            rdoShow12Hours.checked = true;
            rdoShow24Hours.checked = false;
        }
        else {
            rdoShow12Hours.checked = false;
            rdoShow24Hours.checked = true;
        }
    }





    var setTimeFormatAMPM = System.Gadget.Settings.read("settingsTimeFormat12HourShowAMPM");
    if (setTimeFormatAMPM == "") {
        rdoShow12HoursPMOnly.checked = false;
        rdoShow12HoursAMPM.checked = true;
    }
    else {
        if (setTimeFormatAMPM == "true") {
            rdoShow12HoursPMOnly.checked = false;
            rdoShow12HoursAMPM.checked = true;
        }
        else {
            rdoShow12HoursPMOnly.checked = true;
            rdoShow12HoursAMPM.checked = false;
        }
    }

    showtheDateClick();
    timeFormatUseClick();
    
}



document.onreadystatechange = function() {
    if (document.readyState == "complete") {
        
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// Save settings on close
//
////////////////////////////////////////////////////////////////////////////////
function SettingsClosing(event) {
    if (event.closeAction == event.Action.commit) {

        System.Gadget.Settings.write("settingsBackgroundCurrent", backgroundsCurrent);

        var set1 = "";
        if (chkShowSeconds.checked == true) { set1 = "true"; } else { set1 = "false"; }
        System.Gadget.Settings.write("settingsShowSeconds", set1);

        var set2 = "";
        if (chkShowDate.checked == true) { set2 = "true"; } else { set2 = "false"; }
        System.Gadget.Settings.write("settingsShowDate", set2);

        var set3 = "";
        if (rdoShowShortDate.checked == true) { set3 = "true"; } else { set3 = "false"; }
        System.Gadget.Settings.write("settingsShowDateFormat", set3);

        var set4 = "";
        if (rdoShow12Hours.checked == true) { set4 = "true"; } else { set4 = "false"; }
        System.Gadget.Settings.write("settingsTimeFormat", set4);

        var set5 = "";
        if (rdoShow12HoursAMPM.checked == true) { set5 = "true"; } else { set5 = "false"; }
        System.Gadget.Settings.write("settingsTimeFormat12HourShowAMPM", set5);


    }

    event.cancel = false;
}


function backgroundPrevious() {
    if (backgroundsCurrent == 1) { backgroundsCurrent = backgroundsMaximum; }
    else { backgroundsCurrent--; }
    
    document.getElementById("backgroundBackgroundChoiceDisplay").src = "images/Default Background " + backgroundsCurrent + ".png";

    document.getElementById("backgroundPickerCurrent").firstChild.nodeValue = backgroundsCurrent;
}

function backgroundNext() {
    if (backgroundsCurrent == backgroundsMaximum) { backgroundsCurrent = 1; }
    else { backgroundsCurrent++; }
    
    document.getElementById("backgroundBackgroundChoiceDisplay").src = "images/Default Background " + backgroundsCurrent + ".png";

    document.getElementById("backgroundPickerCurrent").firstChild.nodeValue = backgroundsCurrent;
}


function showtheDateClick() {
    if (chkShowDate.checked == true) {
        rdoShowShortDate.disabled = false;
        rdoShowLongDate.disabled = false;
    }
    else {
        rdoShowShortDate.disabled = true;
        rdoShowLongDate.disabled = true;
    }
}

function timeFormatUseClick() {
    if (rdoShow12Hours.checked == true) {
        rdoShow12HoursAMPM.disabled = false;
        rdoShow12HoursPMOnly.disabled = false;
    }
    else {
        rdoShow12HoursAMPM.disabled = true;
        rdoShow12HoursPMOnly.disabled = true;
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// Debug: Write error messages to debug logging
//
////////////////////////////////////////////////////////////////////////////////
function handleErr(msg, url, l) {
    System.Debug.outputString("Problem: " + msg + "\nLine: " + l);
    return true;
}